-------------------------------------------------------
-- bcd 7 add cont
-- 2013/2/23
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity bcd7addcont is
	port(
		a0		:in std_logic;
		a1		:in std_logic;
		a2		:in std_logic;
		a3		:in std_logic;
		cy_in	:in std_logic;
		cont	:in std_logic;
		s0		:out std_logic;
		s1		:out std_logic;
		s2		:out std_logic;
		s3		:out std_logic;
		cy_out	:out std_logic
	);
end bcd7addcont;

architecture rtl of bcd7addcont is
	signal input_data	:std_logic_vector(5 downto 0);
	signal output_data	:std_logic_vector(4 downto 0);

begin
	input_data <= cont & cy_in & a3 & a2 & a1 & a0;
	with input_data select
		output_data <= 	"01000" when "010000", -- cont=0 add
						"01001" when "010001",
						"10000" when "010010",
						"10001" when "010011",
						"10010" when "010100",
						"10011" when "010101",
						"10100" when "010110",
						"10101" when "010111",
						"10110" when "011000",
						"10111" when "011001",
						"00111" when "000000",
						"01000" when "000001",
						"01001" when "000010",
						"10000" when "000011",
						"10001" when "000100",
						"10010" when "000101",
						"10011" when "000110",
						"10100" when "000111",
						"10101" when "001000",
						"10110" when "001001",
						
						"00001" when "110000", -- cont=1 no add
						"00010" when "110001",
						"00011" when "110010",
						"00100" when "110011",
						"00101" when "110100",
						"00110" when "110101",
						"00111" when "110110",
						"01000" when "110111",
						"01001" when "111000",
						"10000" when "111001",
						"00000" when "100000",
						"00001" when "100001",
						"00010" when "100010",
						"00011" when "100011",
						"00100" when "100100",
						"00101" when "100101",
						"00110" when "100110",
						"00111" when "100111",
						"01000" when "101000",
						"01001" when "101001",
						"00000" when others;						
					
	s0 <= output_data(0);
	s1 <= output_data(1);
	s2 <= output_data(2);
	s3 <= output_data(3);
	cy_out <= output_data(4);

end rtl;